--幻灵Item

Lua_EidolonItem = class("Lua_EidolonItem", Lua_ListCell);
function Lua_EidolonItem:ctor(p)
    self:superCall("ctor", p, "EidolonItem_skin");
end


function Lua_EidolonItem:buildShowItem()
    self:superCall("buildShowItem");
    self.red:setEnable(false);
    if self.starArr == nil then
	    self.starArr = Array();
	    local len = DataCenter.eidolonUtil.maxStarNum;
		for i=1,len do
			local star = UICreate.createUIAtlasImage(self.content, "iconantlas1", "star_0", 0, 0, 0, 0);
			star:setDepth(10);
			star:setLocation(-80+i*27,-90,0);
			star:setSacle(0.55,0.55,0.55)
			star:setEnable(false);
			self.starArr:add(star);
		end
	end
end

function Lua_EidolonItem:setData(data)
	self.data = data;
	self.bg:setAltas("eidolon","color_"..data.color);
	self.icon:setUrl(data.atlas_name);
	self.name.text = data.item_name;
	self.lvl.text = data.sort;
	self.select:setEnable(false);

	if data.checkEidolonItemRed == true then
		self.red:setEnable(true);
	else
		self.red:setEnable(false);
	end
	local len = self.starArr:getSize();
	for i=1,len do
		if data.isUpgardStar == true then
        	self.starArr[i]:setEnable(true);
			if i <= data.star_lvl then
				self.starArr[i]:setGray(false);
			else
				self.starArr[i]:setGray(true);
			end
		else
			self.starArr[i]:setEnable(false);
		end
	end

	if data.activation_state == 0 then
		self.icon:setGray(true);
	else
		self.icon:setGray(false);
	end
end

function Lua_EidolonItem:onPlayerSoundClick(go)
	DataCenter.eidolonData.selectItemId = self.data.id;
	DataCenter.eidolonData.eidolonItemSelectIndex = self.data.sort;
	Lua_MsgUtil.callFunc("UPDATE_EIDOLON_ITEM", self.data);
end

function Lua_EidolonItem:onSelectionChange(val)
    self:superCall("onSelectionChange", val);
    if self.select ~= nil then
        if val == true then
            self.select:setEnable(true);
        else
            self.select:setEnable(false);
        end
    end
end

function Lua_EidolonItem:dispose()
	self:superCall("dispose");
end