-- 幻灵

checkRequire("Lua_EidolonItem");
checkRequire("Lua_EidolonAttrPanel");
Lua_EidolonPanel  = class("Lua_EidolonPanel",Lua_DisplayObject);
function Lua_EidolonPanel:ctor(p) 
    self:superCall("ctor", p,"EidolonPanel_skin");
end

function Lua_EidolonPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.starBtn:setEnable(false);
    self.resolveRed:setEnable(false);
    self.starRed:setEnable(false);
    if self.starArr == nil then
        self.starArr = Array();
        local len = DataCenter.eidolonUtil.maxStarNum;
        for i=1,len do
            local star = UICreate.createUIAtlasImage(self.content, "iconantlas1", "star_0", 0, 0, 0, 0);
            star:setDepth(10);
            star:setLocation(230+i*35,15,0);
            star:setSacle(0.7,0.7,0.7);
            star:setGray(true);
            self.starArr:add(star);
        end
    end

    self.fightNum = Lua_NumberImage.new(self.content);
    self.fightNum.prefix = "f_";
    self.fightNum:setDepth(7);
    self.fightNum.numWidth = 14;
    self.fightNum:setLocation(215, 51, 0);

    if self.image == nil then
        self.image = Lua_ToolImage.new(self.content);
        self.image:setDepth(6);
        self.image:setDepth(6);
        self.image:setScale(0.85,0.85,0.85);
        self.image:setLocation(210,-211,0);
    end

    self.help:addClickFuntion(self, self.onHelpClick);
    self.subBtn:addClickFuntion(self, self.onGoingClick);
    self.propBtn:addClickFuntion(self, self.onPropBtnClick);        -- 属性
    self.starBtn:addClickFuntion(self, self.onUpgardStarClick);     -- 升星
    self.resolveBtn:addClickFuntion(self, self.onResolveBtnClick);  -- 分解
    self.intensifyBtn:addClickFuntion(self, self.onIntensifyClick); -- 强化
    
    self:addLuaEvent("UPDATE_SELECT_BTN_ITEM", self, self.onUpSelectButtonClick);   -- 点击button
    self:addLuaEvent("UPDATE_EIDOLON_ITEM", self, self.updateEidolonItemInfo);-- 点击Item

    self.leftDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 174, 526));
    self.leftDragList:setLocation(-520, 10, 0);
    self.leftDragList:setListCell(EidolonSelectItem, 70, 174, 1);

    self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 576, 522));
    self.dragList:setLocation(-138, 10, 0);
    self.dragList:setListCell(Lua_EidolonItem, 246, 192, 3);
    
    self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 350, 140));
    self.dragContainer:setLocation(370, -80, 0);
    self.attrPanel = Lua_EidolonAttrPanel.new(self.content);
    self.dragContainer:addSubContainer(self.attrPanel, true);

    Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sOpenEidolonPanelInfo();
    self:addLuaEvent("UPDATE_EIDOLON_INFO", self, self.updateStarSpiritPanel);
    self:addLuaEvent("UPDATE_ACTIVATION_INFO", self, self.onUpSelectButtonClick);
    self:addLuaEvent("UPDATE_Intensify_INFO", self, self.onUpSelectButtonClick);
    self:addLuaEvent("UPDATE_UPGARD_STAR_INFO", self, self.onUpSelectButtonClick);
    self:addLuaEvent("UPDATE_EIDOLON_RESOLVE_INFO", self, self.onUpSelectButtonClick);
    
    self:addLuaEvent("PACK_EIDOLON_UPDATE", self, self.onUpSelectButtonClick);-- 背包获取道具刷新界面
end

function Lua_EidolonPanel:updateStarSpiritPanel()   
    local buttonInfo = DataCenter.eidolonUtil.getButtonInfo;
    local btn_select_index = DataCenter.eidolonData.eidolonBtnSelectIndex;

    self.leftDragList:setLuaArrayData(buttonInfo, false);
    self.leftDragList:setSelected(btn_select_index);
    self.leftDragList.showList[btn_select_index]:onPlayerSoundClick();

end

function Lua_EidolonPanel:onUpSelectButtonClick()
    local btn_select_index = DataCenter.eidolonData.eidolonBtnSelectIndex;  -- 按钮索引
    local item_select_index = DataCenter.eidolonData.eidolonItemSelectIndex;-- 幻灵Item索引
    local selectItemId = DataCenter.eidolonData.selectItemId;               -- 幻灵ItemID

    local itemInfo = DataCenter.eidolonData:getArrByEidolonTypeInfo(btn_select_index);
    self.dragList:setLuaArrayData(itemInfo, false);

    if selectItemId == nil then
        local info  = DataCenter.eidolonData:getArrByEidolonInfo(itemInfo[1].id);
        self:updateEidolonItemInfo(info);
        DataCenter.eidolonData.selectItemId = itemInfo[1].id;
        self.dragList:moveToIndex(item_select_index,true)
    else
        local info  = DataCenter.eidolonData:getArrByEidolonInfo(selectItemId);
        self:updateEidolonItemInfo(info);
    end
    self.dragList:setSelected(item_select_index);
    if DataCenter.eidolonData:isShowEidolonResolveRed() == true then
        self.resolveRed:setEnable(true);
    else
        self.resolveRed:setEnable(false);
    end

    self:updateBenSelectRed(); -- 更新Btn红点状态
end

function Lua_EidolonPanel:updateBenSelectRed()
    if self.leftDragList ~= nil then
        local arr = self.leftDragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateItemRed();
        end
    end
end

function Lua_EidolonPanel:updateEidolonItemInfo(data)
    self.data = data;
    self.nameTxt.text = data.name;
    self.lvl.text = data.left_lvl;
    self.fightNum.num = data.eidolonBaseForce;
    self.fightNum:setNumScale(0.7,0.7,0.7);
    -- body
    if data.isUpgardStar == true then
        self.starBtn:setEnable(true);
    else
        self.starBtn:setEnable(false);
    end

    self.image.mainContent:SetActive(true);
    if data.activation_state == 1 then -- 是否激活
        self.unrealObg:SetActive(false);
        self.showObg:SetActive(false);
        self.war_bg:setEnable(true);
        self.fightNum:setNumEnable(true);
        self.intensifyBtn.label = LanUtil.getValue(124601);
        if data.isMaxIntensify == true then
            self.intensifyBtn:setBtnEnable(false);
            self.intensifyBtn.label = LanUtil.getValue(141320);
            self.dragContainer:setLocation(450, -80, 0);

            self.image.mainContent:SetActive(false);
        else
            self.intensifyBtn:setBtnEnable(true);
            self.dragContainer:setLocation(370, -80, 0);

            self.image.data = data.intensify_item;
            self.image:showNumLimit(data.intensify_item.bagNum,data.intensify_item.needNum,2);
        end
    else
        self.dragContainer:setLocation(370, -80, 0);
        self.war_bg:setEnable(false);
        self.fightNum:setNumEnable(false);
        self.unrealObg:SetActive(true);
        self.intensifyBtn:setBtnEnable(true);
        self.intensifyBtn.label = LanUtil.getValue(110351);
        self.image.data = nil;--
        self.image.mainContent:SetActive(true);
        self.image.data = data.activation_item;
        self.image:showNumLimit(data.activation_item.bagNum,data.activation_item.needNum,2);
        if data.depict ~= nil then
            self.showObg:SetActive(true);
            self.show_lab.text = data.depict;
        else
            self.showObg:SetActive(false);
        end
    end

    local len = self.starArr:getSize();
    for i=1,len do
        if data.isUpgardStar == true then
            self.starArr[i]:setEnable(true);
            if i <= data.star_lvl then
                self.starArr[i]:setGray(false);
            else
                self.starArr[i]:setGray(true);
            end
        else
            self.starArr[i]:setEnable(false);
        end
    end

    self.attrPanel:setData(data.eidolonBaseProp);
    self.dragContainer.canDrag = false;
    self.dragContainer:updateChildPos();

    if  data.isShowActivationRed == true or data.isShowUpgardRed == true then
        self.intensifyRed:setEnable(true);
    else
        self.intensifyRed:setEnable(false);
    end

    if data.isShowStarUpgardRed then
        self.starRed:setEnable(true);
    else
        self.starRed:setEnable(false);
    end

    self:showEidolonModel();
end

function Lua_EidolonPanel:showEidolonModel()
    local modelStr="/model/"..tostring(self.data.illusion)
    if self.monsEffect ~= nil then
        self.monsEffect:dispose();
        self.monsEffect = nil;
    end

    if self.monsEffect == nil then
        self.monsEffect = UICreate.createUIEffect(self.content, modelStr,self.data.illusion, 0, 0);
        self.monsEffect:setSacle(self.data.modelsca[1],self.data.modelsca[1],self.data.modelsca[1]); --模型比例
        self.monsEffect:SetRenderQueue(self.star_bg, -1, 2);
        self.monsEffect:setLocation(self.data.modelpos[1], self.data.modelpos[2], self.data.modelpos[3]);
        self.monsEffect:setRot(self.data.modelros[1], self.data.modelros[2], self.data.modelros[3]);
    end
    self.monsEffect:setUrl(modelStr, self.data.illusion);
    self.monsEffect:setGray(self.data.activation_state ~= 1);
end

function Lua_EidolonPanel:onUpgardStarClick() -- 升星
    if self.data.activation_state  == 1 then
        Lua_WindowUtil.openWin("Lua_EidolonUpgardStarWindow", WinParam.ACTION_OPEN);
    else
        OperateAlert.show(LanUtil.getValue(142015));
    end
end

function Lua_EidolonPanel:onIntensifyClick() -- 强化
    if self.data.activation_state == 1 then
        Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sIntensifyEidolon(self.data.color,self.data.id)
    else
        Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sActivationEidolon(self.data.color,self.data.id)
    end
end

function Lua_EidolonPanel:onPropBtnClick() -- 属性
    Lua_WindowUtil.openWin("Lua_EidolonPropertyWindow", WinParam.ACTION_OPEN);
end

function Lua_EidolonPanel:onResolveBtnClick() -- 分解
    Lua_WindowUtil.openWin("Lua_EidolonResolveWindow", WinParam.ACTION_OPEN);
end

function Lua_EidolonPanel:onGoingClick() -- 前往副本
    Lua_WindowUtil.openWin("Lua_EidolonWindow", WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_CopyHuanLingWindow", WinParam.ACTION_OPEN, 16);
end

function Lua_EidolonPanel:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(142007));
end

function Lua_EidolonPanel:dispose()   
    self:superCall("dispose");

    if self.leftDragList ~= nil then
        self.leftDragList:dispose()
        self.leftDragList = nil;
    end

    if self.dragList ~= nil then
        self.dragList:dispose()
        self.dragList = nil;
    end

    if self.dragContainer ~= nil then
        self.dragContainer:dispose();
    end

    if self._modelEffect ~= nil then
        self._modelEffect:dispose();
    end
    DataCenter.eidolonData.selectItemId = nil;
    DataCenter.eidolonData.btnSelectedIndex = nil;
    DataCenter.eidolonData.eidolonBtnSelectIndex = 1;
    DataCenter.eidolonData.eidolonItemSelectIndex = 1;
end













EidolonSelectItem = class("EidolonSelectItem", Lua_ListCell);
function EidolonSelectItem:ctor(p)
    self:superCall("ctor", p,nil); 
end

function EidolonSelectItem:buildShowItem()
    self:superCall("buildShowItem");

    self.btnBg = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0,0);
    self.btnBg:SetDimensions(170, 64);
    self.btnBg:setDepth(8);

    self.btnTxt = UICreate.createLabel(self.content, "", 0, 0, 160, 30, 24);
    self.btnTxt.fontSize = 24;
    self.btnTxt.pivot = UIWidget.Pivot.Center;
    self.btnTxt:setDepth(15);
    
    self.redDot = UICreate.createUIAtlasImage(self.content,"iconantlas4","redDot",70,12,0,0)
    self.redDot:setDepth(16);
    self.redDot.clickScale = false;
    self.redDot.name = "redDot"
end

function EidolonSelectItem:setData(data)
    self.data = data;
    self.btnTxt.text = data.name;

    self:updateItemRed();
end

function EidolonSelectItem:updateItemRed()
    local isShowRed = DataCenter.eidolonData:isShowBtnEidolonRed(self.data.index);
    if isShowRed == true then
        self.redDot:setEnable(true);
    else
        self.redDot:setEnable(false);
    end
end

function EidolonSelectItem:onPlayerSoundClick(go)
    if DataCenter.eidolonData.btnSelectedIndex == self.data.index then
        return;
    end
    DataCenter.eidolonData.btnSelectedIndex = self.data.index;

    DataCenter.eidolonData.eidolonBtnSelectIndex = self.data.index;
    DataCenter.eidolonData.eidolonItemSelectIndex = 1;
    DataCenter.eidolonData.selectItemId = nil;
    Lua_MsgUtil.callFunc("UPDATE_SELECT_BTN_ITEM");
end

function EidolonSelectItem:onSelectionChange(val)
    self:superCall("onSelectionChange", val);
    if self.btnBg ~= nil then
        if val == true then
            self.btnBg:setAltas("iconantlas1", "tab4_souchong_select");
            self.btnTxt.colorStr = Lua_ColorDefine.transColor("883a0b");
        else
            self.btnBg:setAltas("iconantlas1", "tab4_souchong_normal");
            self.btnTxt.colorStr = Lua_ColorDefine.transColor("192e41");
        end
    end
end

function EidolonSelectItem:dispose()
    self:superCall("dispose");
end