--幻灵分解

Lua_EidolonResolveWindow = class("Lua_EidolonResolveWindow", Lua_SecondSizeWindow)
function Lua_EidolonResolveWindow:ctor()
    self:superCall("ctor");
    self.resolveArr = Array();
    self.windowName = "Lua_EidolonResolveWindow";
    self.skinName = "EidolonResolveWindow_skin";
    self.titleText = LanUtil.getValue(142009);
end

function Lua_EidolonResolveWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 962, 424));
    self.recordsList:setLocation(6, 21, 0);
    self.recordsList:setListCell(Lua_EidolonResolveItem, 90, 97, 10);
    
    self.spr:setAltas("item16", tostring(DataCenter.eidolonUtil.eidolon_ecompose_id));
    self.spr.clickScale = false;

    self.help:addClickFuntion(self, self.onHelpClick);
    self.spr:addClickFuntion(self, self.onOpenEidolonTips);
    self.resolveBtn:addClickFuntion(self, self.onResolveClick);
 
    self:onUpdatePackInfo();
    self:addLuaEvent("UPDATE_EIDOLON_SELCET", self, self.onSelectCloakInfo);
    self:addLuaEvent("UPDATE_EIDOLON_RESOLVE_INFO", self, self.onUpdatePackInfo);
    self:addLuaEvent("PACK_EIDOLON_UPDATE", self, self.onUpdatePackInfo); -- 背包获取新道具 更新分解数据
end

function Lua_EidolonResolveWindow:onUpdatePackInfo()--背包数据
    local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.EIDOLON_ITEM});
    
    self.resolveList = Array()
    local len = DataCenter.eidolonUtil.pack_size;
    for i=1,len do
        if arr[i] ~= nil then
            self.resolveList:add({vo = arr[i], isSelect = true, weight = arr[i].color});
        else
            self.resolveList:add({vo = nil, isSelect = false, weight=0});
        end
    end
    self.resolveList:sort("weight", true);
    self.recordsList:setLuaArrayData(self.resolveList, false);

    self:onResolveEidolonData()--分解数据
end

function Lua_EidolonResolveWindow:onResolveEidolonData()--分解数据
    self.resolveArr:clear();
    local len = self.resolveList:getSize();
    for i=1,len do
        if self.resolveList[i].isSelect == true then
            local list  = {};
            list.index = self.resolveList[i].vo.index;
            list.id = self.resolveList[i].vo.id;
            list.decompose = DataCenter.eidolonData:getArrByEidolonInfo(self.resolveList[i].vo.id).decompose*self.resolveList[i].vo.count;
            self.resolveArr:add(list);
        end
    end

    local num = DataCenter.eidolonData.fantasy_soul_stone;
    if self.resolveArr:getSize() > 0  then
        local resolveNum = DataCenter.eidolonUtil:eidolonResolveNum(self.resolveArr);
        self.resolveTxt.text = LanUtil.formateStr(LanUtil.getValue(128524),tostring(num),tostring(resolveNum));
    else
        self.resolveTxt.text = LanUtil.formateStr(LanUtil.getValue(128525),tostring(num));
    end

    self:updateCardResolveRed()--红点显示
    --背包数据
end

function Lua_EidolonResolveWindow:onSelectCloakInfo()--点击 单个灵纹 刷新界面
    self:onResolveEidolonData();
    self:updateSelect();
end

function Lua_EidolonResolveWindow:onResolveClick()
    local len = self.resolveArr:getSize()
    if len > 0 then
        self:onSubCallback();
    else
        OperateAlert.show(LanUtil.getValue(142011));
    end
end

function Lua_EidolonResolveWindow:onSubCallback()
    Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sResolveEidolon(self.resolveArr)
    if self.resolveList ~= nil then
        self.resolveList:clear();
    end

    if self.resolveArr ~= nil then
        self.resolveArr:clear();
    end
end

function Lua_EidolonResolveWindow:updateSelect()
    if self.recordsList ~= nil then
        local arr = self.recordsList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect();
        end
    end
end

function Lua_EidolonResolveWindow:updateCardResolveRed() --红点更新
    local isShowResolveRed = DataCenter.eidolonData:isShowEidolonResolveRed();
    if isShowResolveRed == true then
        self:showRedDot(true);--分解红点显示
    else
        self:showRedDot(false);
    end
end

function Lua_EidolonResolveWindow:showRedDot(val)--红点显示
    if val == true then
        if self._redDotIcon == nil then
            self._redDotIcon = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot",501,-255, 0, 0);
            self._redDotIcon:setDepth(7);
            self._redDotIcon.name = "redDotIcon1";
        end
        self._redDotIcon:setEnable(true);
    else
        if self._redDotIcon ~= nil then
            self._redDotIcon:setEnable(false);
        end
    end
end

function Lua_EidolonResolveWindow:onOpenEidolonTips()--幻灵石Tips
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(209000301),false)
end

function Lua_EidolonResolveWindow:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(142016));
end



function Lua_EidolonResolveWindow:dispose()
    if self.recordsList ~= nil then
        self.recordsList:dispose()
        self.recordsList = nil;
    end
    if self.resolveList ~= nil then
        self.resolveList:clear();
        self.resolveList = nil; 
    end
    if self.resolveArr ~= nil then
        self.resolveArr:clear();
        self.resolveArr = nil; 
    end
    self:superCall("dispose");
end

















Lua_EidolonResolveItem = class("Lua_EidolonResolveItem", Lua_ListCell);
function Lua_EidolonResolveItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_EidolonResolveItem:buildShowItem()
    self:superCall("buildShowItem");
    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.content);
        self.itemImage:setDepth(3);
        self.itemImage:setLocation(0,6,0);
        self.itemImage:setCanClick(false);
    end
end

 function Lua_EidolonResolveItem:setData(data)
    self.data = data;
    self.vo = data.vo;
    self.itemImage.data = self.vo;
    self.itemImage:showBetterTip(0);
    -- if self.vo ~= nil then
    --     if self.vo.color >= 2 then
    --         self.itemImage:showRoundEff(true);
    --     else
    --         self.itemImage:showRoundEff(false);
    --     end
        
    -- end
    self:updateSelect();
 end

function Lua_EidolonResolveItem:updateSelect()
    if self.data.isSelect == true then
        if self.shade == nil then
            self.shade = UICreate.createUIAtlasImage(self.content, "iconantlas1", "tick_green", 0, 6, 0, 0);
            self.shade:setDepth(10);
        end
        self.shade:setEnable(true);
        self.itemImage:setGray(true);
    else
        if self.shade ~= nil then
            self.shade:setEnable(false);
        end
        
        self.itemImage:setGray(false);
    end
end

function Lua_EidolonResolveItem:onPlayerSoundClick(go)
    if self.vo ~= nil then
        if self.data.isSelect == true then
            self.data.isSelect = false;
        else
            self.data.isSelect = true;
        end
        Lua_MsgUtil.callFunc("UPDATE_EIDOLON_SELCET");
    end
end

function Lua_EidolonResolveItem:dispose()
    self:superCall("dispose");
end