--幻灵升星

Lua_EidolonUpgardStarWindow = class("Lua_EidolonUpgardStarWindow", Lua_Window)
function Lua_EidolonUpgardStarWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_EidolonUpgardStarWindow";
    self.skinName = "EidolonStarPanel_skin";
end

function Lua_EidolonUpgardStarWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.red:setEnable(false);
    if self.image == nil then
        self.image = Lua_ToolImage.new(self.rightObg);
        self.image:setDepth(6);
        self.image:setDepth(6);
        self.image:setScale(0.85,0.85,0.85);
        self.image:setLocation(160,-225,0);
    end

    if self.starLeftArr == nil then
        self.starLeftArr = Array();
        local len1 = DataCenter.eidolonUtil.maxStarNum;
        for i=1,len1 do
            local star1 = UICreate.createUIAtlasImage(self.leftObg, "iconantlas1", "star_0", 0, 0, 0, 0);
            star1:setDepth(10);
            star1:setLocation(-303+i*27,15,0);
            star1:setSacle(0.55,0.55,0.55);
            star1:setGray(true);
            self.starLeftArr:add(star1);
        end
    end

    if self.starRigthArr == nil then
        self.starRigthArr = Array();
        local len2 = DataCenter.eidolonUtil.maxStarNum;
        for i=1,len2 do
            local star2 = UICreate.createUIAtlasImage(self.rightObg, "iconantlas1", "star_0", 0, 0, 0, 0);
            star2:setDepth(10);
            star2:setLocation(137+i*27,15,0);
            star2:setSacle(0.55,0.55,0.55);
            star2:setGray(true);
            self.starRigthArr:add(star2);
        end
    end

    self.subBtn:addClickFuntion(self, self.onUpgradeBtnClick);  -- 升星
    self:addLuaEvent("UPDATE_UPGARD_STAR_INFO",self, self.updateUpgardStarPanel);
    self:updateUpgardStarPanel();
end

-- 升星数据
function Lua_EidolonUpgardStarWindow:updateUpgardStarPanel()
    
    local selectItemId =  DataCenter.eidolonData.selectItemId;
    self.data = DataCenter.eidolonData:getArrByEidolonInfo(selectItemId);

    self.left_bg:setAltas("eidolon","color_"..self.data.color);
    self.left_icon:setUrl(self.data.atlas_name);
    self.left_name.text = self.data.item_name;
    self.left_lvl.text = self.data.sort;
    self.left_prop.text = self.data.eidolonStarBaseProp;

    local len1 = self.starLeftArr:getSize();
    local len2 = self.starRigthArr:getSize();
    if self.data.isMaxUpgardStar ~= true then -- 是否最大等级
        self.leftObg:SetActive(true);
        self.rightObg:SetActive(true);
        self.left_prop:setLocation(-315,-35,0);
        -- self.leftObg.gameObject.transform.localPosition = Vector3(0, 0, 0);
        LuaUtil.setObjPos(self.leftObg.gameObject, 0, 0, 0);

        self.image.data = self.data.upgard_star_Item;
        self.image:showNumLimit(self.data.upgard_star_Item.bagNum,self.data.upgard_star_Item.needNum,2);

        self.right_bg:setAltas("eidolon","color_"..self.data.color);
        self.right_icon:setUrl(self.data.atlas_name);
        self.right_name.text = self.data.item_name;
        self.right_lvl.text = self.data.sort;
        self.right_prop.text = self.data.eidolonStarNextProp;
        self.subBtn:setBtnEnable(true);
        self.subBtn.label = LanUtil.getValue(142008);

        for i=1,len1 do
            if i <= self.data.star_lvl then
                self.starLeftArr[i]:setGray(false);
            else
                self.starLeftArr[i]:setGray(true);
            end
        end

        for i=1,len2 do
            if i <= self.data.star_lvl+1 then
                self.starRigthArr[i]:setGray(false);
            else
                self.starRigthArr[i]:setGray(true);
            end
        end

        if self.data.isShowStarUpgardRed == true then
            self.red:setEnable(true);
        else
            self.red:setEnable(false);
        end
    else
        for i=1,len1 do
            if i <= self.data.star_lvl then
                self.starLeftArr[i]:setGray(false);
            else
                self.starLeftArr[i]:setGray(true);
            end
        end
        self.red:setEnable(false);
        self.leftObg:SetActive(true);
        self.rightObg:SetActive(false);
        self.left_prop:setLocation(-297,-35,0);
        self.subBtn:setBtnEnable(false);
        self.subBtn.label = LanUtil.getValue(110033);
        -- self.leftObg.gameObject.transform.localPosition = Vector3(220, 0, 0);
        LuaUtil.setObjPos(self.leftObg.gameObject, 220, 0, 0);
    end
end

-- 升星数据
function Lua_EidolonUpgardStarWindow:onUpgradeBtnClick()
    Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sUpgradeStarEidolon(self.data.color,self.data.id)
end