-- 星灵

checkRequire("Lua_StarSpiritItem");
Lua_StarSpiritPanel  = class("Lua_StarSpiritPanel",Lua_DisplayObject);
function Lua_StarSpiritPanel:ctor(p) 
    self:superCall("ctor", p,"StarSpiritPanel_skin");
end

function Lua_StarSpiritPanel:buildShowItem()
    self:superCall("buildShowItem");

    local poses = {{-520,-20},{-501,68},{-456,140},{-386,198},{-297,230},{-199,230},{-104,198},{-34,140},{11,68},{31,-20}};
    self.itemArr = Array();
    for i, v in ipairs(poses) do
        local item = Lua_StarSpiritItem.new(self.content);--左槽
        item:setLocation(v[1], v[2], 0);
        item:setShowType(i);
        item:setShowEff(true);
        item:setShowUIEffect(false);
        self.itemArr:add(item);
    end
    self.red:setEnable(false);
    self.itemImage = Lua_ToolImage.new(self.subObg);
    self.itemImage:setLocation(90,-300,0);
    self.itemImage:setDepth(10);

    self.fightNum = Lua_NumberImage.new(self.content);
    self.fightNum.prefix = "f_";
    self.fightNum:setDepth(7);
    self.fightNum:setLocation(280, 240, 0);
    
    self.skill_di.clickScale = false;
    self.help:addClickFuntion(self, self.onHelpClick);
    self.subBtn:addClickFuntion(self, self.onSubClick);
    self.updradeBtn:addClickFuntion(self, self.onUpGradeBtn);
    self.goBtn:addClickFuntion(self, self.onGoingClick);
    self.skill_di:addClickFuntion(self, self.onSkillBtnClick);   -- 技能
    self.leftBtn:addClickFuntion(self, self.onLeftBtnClick);
    self.rightBtn:addClickFuntion(self, self.onRightBtnClick);

    Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sOpenStarSpiritPanelInfo();
    self:addLuaEvent("UPDATE_STAR_SPIRIT_INFO", self, self.updateStarSpiritPanel);
    self:addLuaEvent("UPDATE_STAR_SPIRIT_EFF", self, self.onSuccessEvent); --特效
end

function Lua_StarSpiritPanel:updateStarSpiritPanel()
    self.fightNum.num = DataCenter.eidolonData.starSpiritForce;
    self.prop.text = DataCenter.eidolonData.starSpiritBaseProp;
    self.lvl.text = LanUtil.formateStr(LanUtil.getValue(142002), tostring(DataCenter.eidolonData.star_soul_lvl));
    self.updradeBtn:setBtnEnable(true);
    if DataCenter.eidolonUtil.isMaxLvl == true then
        self.subObg:SetActive(false);
        self.sprObg:SetActive(false);
        self.updradeBtn:setBtnEnable(false);
        self.updradeObg:SetActive(true);
        self.prop:setLocation(260,122,0);
        self.red:setEnable(false);
        self.updrade.text = LanUtil.getValue(142017);
    else
        if DataCenter.eidolonData.isCanBreak == false then
            self.subObg:SetActive(false);
            self.updradeObg:SetActive(true);
            self.updrade.text = LanUtil.formateStr(LanUtil.getValue(142003), tostring(DataCenter.eidolonData.star_soul_lvl+1));
            if DataCenter.eidolonData.isShowStarUpGardRed == true then
                self.red:setEnable(true);
            else
                self.red:setEnable(false);
            end
        else
            local data = DataCenter.eidolonUtil:getStarSpiritVo(DataCenter.eidolonData.star_soul_lvl);
            local itemVo = data.itemVo;
            self.itemImage.data = itemVo;
            self.itemImage:showNumLimit(itemVo.bagNum,itemVo.needNum,2);
            self.updrade.text = data.upgrade_cond;
            self.subObg:SetActive(true);
            self.updradeObg:SetActive(false);

            if data.isShowBackRed == true then
                self.red:setEnable(true);
            else
                self.red:setEnable(false);
            end
        end
        self.next_prop.text = DataCenter.eidolonData.starSpiritNexteProp;
        self.prop:setLocation(189,122,0);
    end

    self.skillInfo = DataCenter.eidolonData.starSpiritArr[1];
    if DataCenter.eidolonData.break_count == 0 then
        self.skill_di:setGray(true);
        self.skill_icon:setGray(true);
        self.skill_icon:setAltas(tostring(self.skillInfo.skillVo.atlas),tostring(self.skillInfo.skillVo.skillIcon));
    else
        self.skill_di:setGray(false);
        self.skill_icon:setGray(false);
        self.skill_icon:setAltas(tostring(self.skillInfo.skillVo.atlas),tostring(self.skillInfo.skillVo.skillIcon));
    end

    self:updateSelsetType(DataCenter.eidolonData.select_index);
    DataCenter.eidolonData.selectIndex = DataCenter.eidolonData.select_index;
    -- self:updateIsShowRed();-- 红点
end

function Lua_StarSpiritPanel:updateSelsetType(index) -- 更新选择星灵
    local data = DataCenter.eidolonUtil:getStarSpiritVo(index*10);

    self.nameTxt.text = data.name;
    self.starSpiritBg:setUrl(data.image_name);

    if  DataCenter.eidolonData.is_max_select_index == true then
        self.leftBtn:setGray(true);
        self.leftBtn.mouseEnable = true;
        self.rightBtn.mouseEnable = false;
        self.rightBtn:setGray(false);
    else
        if index == DataCenter.eidolonData.select_index then -- 选择最大页数
            self.rightBtn:setGray(true);
            self.rightBtn.mouseEnable = false;
            if index == 1 then
                self.leftBtn:setGray(true);
                self.leftBtn.mouseEnable = false;
            else
                self.leftBtn:setGray(false);
                self.leftBtn.mouseEnable = true;
            end
        else
            self.rightBtn:setGray(false);
            self.rightBtn.mouseEnable = true;

            if index == 1 then
                self.leftBtn:setGray(true);
                self.leftBtn.mouseEnable = false;
            else
                self.leftBtn:setGray(false);
                self.leftBtn.mouseEnable = true;
            end
        end
    end

    local eff_num = DataCenter.eidolonData:star_spirit_lvl(index);
    local len = self.itemArr:getSize();
    for i=1,len do
        if i <= eff_num then
            self.itemArr[i]:setShowEff(false);
        else
            self.itemArr[i]:setShowEff(true);
        end
    end
end

function Lua_StarSpiritPanel:onLeftBtnClick() -- 上一页
    DataCenter.eidolonData.selectIndex = DataCenter.eidolonData.selectIndex -1;
    if DataCenter.eidolonData.selectIndex == 0 then
        DataCenter.eidolonData.selectIndex = 1;
    end
    self:updateSelsetType(DataCenter.eidolonData.selectIndex);
end

function Lua_StarSpiritPanel:onRightBtnClick() -- 下一页
    DataCenter.eidolonData.selectIndex = DataCenter.eidolonData.selectIndex +1;
    if  DataCenter.eidolonData.is_max_select_index == true then
        DataCenter.eidolonData.selectIndex = DataCenter.eidolonUtil.starSpiritMaxIndex;
    end
    self:updateSelsetType(DataCenter.eidolonData.selectIndex);
end

function Lua_StarSpiritPanel:onSuccessEvent()
    if self.effect1 == nil then
        self.effect1 = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_tupochenggong", "gui_tupochenggong", 0, -150);
    else
        self.effect1.mainContent:SetActive(false);
        self.effect1.mainContent:SetActive(true);
    end
    self.effect1:SetRenderQueue(self.wzd, 100, 2,false);
end

function Lua_StarSpiritPanel:onUpGradeBtn() -- 升级
    Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sUpgradeStarSpirit(1);
end

function Lua_StarSpiritPanel:onSubClick() -- 突破
    Lua_ProxyManager.getProxy("Lua_EidolonProxy"):sUpgradeStarSpirit(2);
end

function Lua_StarSpiritPanel:onSkillBtnClick() -- 技能
    Lua_WindowUtil.openWin("Lua_EidolonSkillWindow",nil,self.skillInfo);
end

function Lua_StarSpiritPanel:onGoingClick() -- 前往副本
    Lua_WindowUtil.openWin("Lua_EidolonWindow", WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_CopyHuanLingWindow", WinParam.ACTION_OPEN,16);
end

function Lua_StarSpiritPanel:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(142018));
end

function Lua_StarSpiritPanel:dispose()   
    self:superCall("dispose");
end